#!/usr/bin/env python

"""
Csound Catalog Indexer:
    
    Makes a single html page for all orc/sco, csd files and creates a link to
    the mp3's

    author: steven yi
    email:  stevenyi@csounds.com
    web:    http://www.csounds.com/stevenyi
    
    version 1.0
    
    released: 8.7.2003
"""

import os
from os.path import isdir, join

#catalogDir = "e:\Csound Catalog"
catalogDir = "/mnt/cdrom/Csound Catalog"
soundFileDir = "0 Catalog Audio"

def makeFileLink(fileName, fullDir):
    fullPath = join(fullDir, fileName)
    
    htmlText = fileName
    
    if fullPath[-3:].lower() == "orc":
        htmlText = htmlText + " <a href='file:///" + fullPath + "'>[orc]</a>"
        htmlText = htmlText + " <a href='file:///" + fullPath[:-3] + "sco'>[sco]</a>"
    elif fullPath[-3:].lower() == "csd":
        htmlText = htmlText + " <a href='file:///" + fullPath + "'>[csd]</a>"
        
    htmlText = htmlText + " <a href='file:///" + join(catalogDir, soundFileDir, fileName[:-3] + "mp3") + "'>[mp3]</a>"
    htmlText = htmlText + "<br>\n"
    
    return htmlText

def makeHTML(dirRoot, level=1):
    dirList = os.listdir(dirRoot)
    
    space = ""
    for k in range(0, level):
        space = space + "&nbsp;&nbsp;&nbsp;&nbsp;"
    
    htmlText = ""
    
    for i in dirList:
        if(i == soundFileDir):
            continue
        fullDir = join(dirRoot, i)
        if(isdir(fullDir)):
            htmlText = htmlText + space + "<b>" + i + "</b><br>\n"
            htmlText = htmlText + makeHTML(fullDir, level + 1)
        elif i[-3:].lower() == "orc" or i[-3:].lower() == "csd":
            htmlText = htmlText + space + makeFileLink(i, dirRoot)

    return htmlText + "<br>"

def makeHeader():
    return  """<html>
    <head>
    <title>Csound Catalog</title>
    <style>
        body { font-family: verdana }
    </style>        
    </head>
    <body>
    <h1>Csound Catalog with Audio 2.1.2</h1>"""
    
def makeFooter():
    return "</body></html>"

    
htmlText = makeHeader()
htmlText = htmlText + makeHTML(catalogDir)
htmlText = htmlText + makeFooter()

f = open("csoundCatalog.html","w")
f.write(htmlText)
f.flush()
f.close()
        




